Given an array nums and a target value k, find the maximum length of a subarray that sums to k. If there isn't one, return 0 instead.
Example 1:
Given nums = [1, -1, 5, -2, 3], k = 3,
return 4. (because the subarray [1, -1, 5, -2] sums to 3 and is the longest)
Example 2:
Given nums = [-2, -1, 2, 1], k = 1,
return 2. (because the subarray [-1, 2] sums to 1 and is the longest)
Follow Up:
Can you do it in O(n) time?
Note:
The sum of the entire nums array is guaranteed to fit within the 32-bit signed integer range.
這題跟560. subarray sum equals k幾乎一毛一樣富岳。
我想到了用map和sum - k 來實(shí)現(xiàn)ONE PASS蛔糯,但是不知道怎么維護(hù)一個類似560題里面那個count的值了。正確答案是用Math.max每次對比當(dāng)前maxLen 和 i - map.get(sum-k)窖式。
思維難度還是有的蚁飒。
這題leetcode收費(fèi)了。我貼一個別人的答案萝喘。注意這里的put始終是put(sum,i)淮逻,不需要取原來的值。因?yàn)槲覀冃枰涗泂um 相同的最早的值阁簸,后面sum - k 在前面map出現(xiàn)過的話爬早,取最出現(xiàn)的那個index就好了。
public class Solution {
public int maxSubArrayLen(int[] nums, int k) {
Map<Integer, Integer> hm = new HashMap<>();
int result = 0, sum = 0;
hm.put(0, -1);
for(int i = 0; i < nums.length; i++) {
sum += nums[i];
if (hm.containsKey(sum - k)) result = Math.max(i - hm.get(sum - k), result);
if (!hm.containsKey(sum)) hm.put(sum, i);
}
return result;
}
}
ref:
https://discuss.leetcode.com/topic/33259/o-n-super-clean-9-line-java-solution-with-hashmap